// ----------------------------------------------------------------------------
/**
 
   Property of Kartech  
   (c) Copyright Kartech 2011

   Regular user license : 

       Regular users of Step2Mach are expected to register the program by paying for it ( Paypal, 35$ + VAT in European Union countries). 

       https://www.paypal.com/cgi-bin/webscr?cmd=_cart&add=1&business=jaroslaw%2Ekarwik%40kartech%2Eorg&item_name=Step2Mach%20software%20license&amount=35&currency_code=USD&lc=US&charset=windows-1250&button_subtype=products 
   
       Source code and bug report/upgrade info will be available on Mach Support forum.
       If you're a registered user, you can do anything you want with the program and source code to modify it as you see fit, except for redistribution. 
       In your own shop, anything goes.

   Professional license: 
   
       If you want to develop your commercial product based on the software, you need to buy special license ( Paypal, 1000$ + VAT in European Union countries) . 
       In such case you get rights to redistribute your product. In binary form, without disclosing your source code.
       You will also get access to premium features like ethernet converter source code and bootloader source code.
       For such case contact me first please - I will generate Paypal invoice for you.
  

   Author:      Jarosaw Karwik
   E-Mail:     jaroslaw.karwik(at)kartech.org
   
**/
// ----------------------------------------------------------------------------




#ifndef MACH_PCLIB_PROTOCOL_H
#define MACH_PCLIB_PROTOCOL_H

#include "types.h"
#include "mach_firmware.h"

#ifdef WIN32
#ifdef _USRDLL
#define FNTYPE  extern "C"  __declspec( dllexport )
#else
#define FNTYPE  extern "C" __declspec( dllimport )
#endif
#define STDCALL __stdcall
#else
#define FNTYPE
#define STDCALL
#endif

////////////////////////////////////////////////////////////////////////////////
// Response status info
////////////////////////////////////////////////////////////////////////////////

#define  S_IDLE            0
#define  S_RUNNING         1
#define  S_ESTOP           2

////////////////////////////////////////////////////////////////////////////////
// Interface function definitions
////////////////////////////////////////////////////////////////////////////////

FNTYPE int  STDCALL Cnc_Init_Controller(void);
FNTYPE int  STDCALL Cnc_Exit_Controller(void);

FNTYPE int	STDCALL Cnc_Communication_Enable(const char * address);
FNTYPE int  STDCALL Cnc_Communication_Disable(void);

FNTYPE int  STDCALL Cnc_Communication_GetSerial(void);


FNTYPE int  STDCALL Cnc_Status_Get(timer_resp_t  * status);

FNTYPE int  STDCALL Cnc_SetCoords(timer_coord_t  * coord);
FNTYPE int  STDCALL Cnc_SetMap(timer_map_t    * map, int map_cnt);
FNTYPE int  STDCALL Cnc_SetOutputs(Uint32_t outputs,Uint32_t mask);

FNTYPE void STDCALL Cnc_SendCommand(command_e cmd,int clear_queue);

FNTYPE int  STDCALL Cnc_GetBufferStatus(void);
FNTYPE int  STDCALL Cnc_IsQueEmpty(void);
FNTYPE int  STDCALL Cnc_GetInputs(void);

FNTYPE int  STDCALL Cnc_SetFrame(timer_frame_t  * frame, int frame_cnt,int replace_queue);


#endif //MACH_PCLIB_PROTOCOL_H
