// ----------------------------------------------------------------------------
/**
 
   Property of Kartech  
   (c) Copyright Kartech 2011

   Regular user license : 

       Regular users of Step2Mach are expected to register the program by paying for it ( Paypal, 35$ + VAT in European Union countries). . 

       https://www.paypal.com/cgi-bin/webscr?cmd=_cart&add=1&business=jaroslaw%2Ekarwik%40kartech%2Eorg&item_name=Step2Mach%20software%20license&amount=35&currency_code=USD&lc=US&charset=windows-1250&button_subtype=products 
   
       Source code and bug report/upgrade info will be available on Mach Support forum.
       If you're a registered user, you can do anything you want with the program and source code to modify it as you see fit, except for redistribution. 
       In your own shop, anything goes.

   Professional license: 
   
       If you want to develop your commercial product based on the software, you need to buy special license ( Paypal, 1000$ + VAT in European Union countries).  . 
       In such case you get rights to redistribute your product. In binary form, without disclosing your source code.
       You will also get access to premium features like ethernet converter source code and bootloader source code.
       For such case contact me first please - I will generate Paypal invoice for you.
  

   Author:      Jarosaw Karwik
   E-Mail:     jaroslaw.karwik(at)kartech.org
   
**/
// ----------------------------------------------------------------------------





#ifndef TIMER_H
#define TIMER_H

#include "..\mach_common\types.h"
#include "..\mach_common\mach_firmware.h"
#include "hwinit.h"



#define TIMER_BUF_LEN   432


#if defined(__DEBUG)
#define PIN_DBG(X_)      LATAbits.LATA0 = X_                
#else
#define PIN_DBG(X_)                  
#endif

typedef struct
{   
    timer_frame_t    * current_step;
    timer_frame_t    * current_jog;
    Uint8_t            inputs; 

    Int16_t            last_valid_id;              
    Uint16_t           slots_head;    
    Uint16_t           slots_tail;
    Uint16_t           slots_used;     
    int                jog_mode;
    Uint16_t           jog_in_mask;
    Uint16_t           jog_in_value;
    
}timer_buffer_t;

typedef struct
{
    Uint32_t           Xac;
    Uint32_t           Yac;
    Uint32_t           Zac;
    Uint32_t           Aac;
}timer_engine_t;


typedef struct
{
    Uint32_t           accumulator;
    Int32_t          * coord_ptr;    
    int                dir_neg; 
    int                pulse;
}timer_jog_engine_t;




extern timer_coord_t    coords;
extern timer_buffer_t   buffer;
extern Uint32_t         tick;

void timer_init(void);

void timer_enable_run(void);
void timer_disable_run(void);
void timer_flush_buffers(void);
void timer_sync_coords(void);
int  timer_execute_frame(Uint8_t * frame_stream,int idx);


#endif
