// ----------------------------------------------------------------------------
/**
 
   Property of Kartech  
   (c) Copyright Kartech 2011

   Regular user license : 

       Regular users of Step2Mach are expected to register the program by paying for it ( Paypal, 35$ + VAT in European Union countries). 

       https://www.paypal.com/cgi-bin/webscr?cmd=_cart&add=1&business=jaroslaw%2Ekarwik%40kartech%2Eorg&item_name=Step2Mach%20software%20license&amount=35&currency_code=USD&lc=US&charset=windows-1250&button_subtype=products 
   
       Source code and bug report/upgrade info will be available on Mach Support forum.
       If you're a registered user, you can do anything you want with the program and source code to modify it as you see fit, except for redistribution. 
       In your own shop, anything goes.

   Professional license: 
   
       If you want to develop your commercial product based on the software, you need to buy special license ( Paypal, 1000$ + VAT in European Union countries) . 
       In such case you get rights to redistribute your product. In binary form, without disclosing your source code.
       You will also get access to premium features like ethernet converter source code and bootloader source code.
       For such case contact me first please - I will generate Paypal invoice for you.
  

   Author:      Jarosaw Karwik
   E-Mail:     jaroslaw.karwik(at)kartech.org
   
**/
// ----------------------------------------------------------------------------


#ifndef MYLICENSE_H
#define MYLICENSE_H

#include <windows.h>
#include <string>
#pragma comment(lib, "advapi32")

#define PAGE_LEN 80

namespace MyLicense
{

	using namespace System;
	using namespace System::IO;
	using namespace System::Text;
	using namespace System::Security::Cryptography;

	inline std::string wchar2s(wchar_t * wchar_string,int size)
	{
		std::string	  result;
		char		  cc[8];
		int			  cnv_size;
		int			  ii,jj;
		
		for(ii =0; ii < size;ii++)
		{
#pragma warning (disable : 4996)
			cnv_size = wctomb ((char*)&cc, wchar_string[ii]);
			for(jj = 0; jj < cnv_size; jj++)
			{
				result += cc[jj];
			}
		}

		return result;
	}

	inline std::string nets2s(System::String^ net_string)
	{
		int ii;
		array<System::Byte>^ byte_array = Encoding::UTF8->GetBytes(net_string);

		std::string	  result;

		result.resize(byte_array->Length);

		for(ii =0; ii< byte_array->Length;ii++)
		{
			result[ii] = byte_array[ii];
		}


		return result;
	}


	public ref class LicenseFile
	{

	private:
			RSACryptoServiceProvider ^   RSA;
	public:
		LicenseFile(void)
		{
			
		}

	protected:
		~LicenseFile()
		{

		}

	public: int GenerateFileKeys(String^ path)
		{
			RSACryptoServiceProvider^ RSA = gcnew (RSACryptoServiceProvider);
			String^ pubk				  = RSA->ToXmlString(false);
            String^ privk				  = RSA->ToXmlString(true);


			StreamWriter^ file;

			file = gcnew StreamWriter(path + "pubkey.txt");
			file->Write(pubk);
			file->Close();

			file = gcnew StreamWriter(path + "privkey.txt");
			file->Write(privk);
			file->Close();


			return 0;
		}

	public: String^  GenerateLicense(String^ Fingerprint,String^  privateKey)
		{
			int	 ii;
			const wchar_t hex_chars[] = L"0123456789ABCDEF";

			RSACryptoServiceProvider^ RSA = gcnew (RSACryptoServiceProvider);

			RSA->FromXmlString(privateKey);

			array<Byte>^ result = RSA->SignData(Encoding::Unicode->GetBytes(Fingerprint),gcnew(SHA1CryptoServiceProvider));
			
			String^ hexResult = gcnew String("");

			for(ii =0; ii < result->Length;ii++)
			{
				hexResult += hex_chars[((result[ii]) & 0xF0)>>4];
				hexResult += hex_chars[(result[ii]) & 0x0F] ;
			}

			return hexResult;
		}

	public: int  CheckLicense(String^ Fingerprint,String^ License,String^ publicKey)
		{
			int				ii;
			array<Byte>^    rawLicense = gcnew array<Byte>(0x80);
			String^			oneByte;
			

			RSACryptoServiceProvider^ RSA = gcnew (RSACryptoServiceProvider);
			RSA->FromXmlString(publicKey);

			for(ii = 0; ii < License->Length/2;ii++)
			{
				oneByte			= gcnew String("");
				oneByte			+=  (wchar_t)License[2*ii];
				oneByte			+=  (wchar_t)License[2*ii+1];
				rawLicense[ii]  = Convert::ToByte(oneByte,16);
			}


			if (RSA->VerifyData(Encoding::Unicode->GetBytes(Fingerprint), gcnew(SHA1CryptoServiceProvider),rawLicense))
			{
				return 0;
			}
			else
			{
				return -1;
			}
		};


	public: String^  GenerateLicensePrintout(String^ Fingerprint,String^ privateKey)
		{
			String^ Printout = gcnew String("");
			String^ LicenseHash;
			int ii;

			LicenseHash = GenerateLicense(Fingerprint,privateKey);

			ii = 0;

			Printout += "<";
			while(ii < (int)Fingerprint->Length)
			{
				Printout += Fingerprint[ii];
				if( (ii % PAGE_LEN) == (PAGE_LEN-1))Printout += ">\n<";			
				ii++;
			}
			Printout += ">\n[";
			ii = 0;
			while(ii <(int) LicenseHash->Length)
			{	
				Printout += LicenseHash[ii];
				if( (ii % PAGE_LEN) == (PAGE_LEN-1))Printout += "]\n[";
			
				ii++;
			}
			Printout += "]\n";

			return Printout;
		};


	public: int CheckLicensePrintout(String^ LicensePrintout,String^ publicKey,String^ * LicenseOwner)
		{
			String^ Hash;
			int	   ii;

			int  inLicenseOwner = 0;
			int  inHash		  = 0;

			ii = 0;

			Hash		= gcnew String("");
			*LicenseOwner = gcnew String("");



			while(ii < (int)LicensePrintout->Length)
			{
				switch(LicensePrintout[ii])
				{
					case '<': inLicenseOwner = 1;break;
					case '>': inLicenseOwner = 0;break;
					case '[': inHash = 1; break;
					case ']': inHash = 0; break;
					default:
					{
						if(inLicenseOwner != 0)*LicenseOwner+= LicensePrintout[ii];
						else if (inHash != 0)Hash+= LicensePrintout[ii];
					}break;
				}
				ii++;
			}

			return CheckLicense(*LicenseOwner,Hash,publicKey);
		};


		public: std::string	  GenerateFingerprint()
		{

			HKEY	  hKey		= 0;
			wchar_t   buf[255]  = {0};
			DWORD	  dwType	= 0;
			DWORD	  dwBufSize;
			int		  ii;
		 
			std::string	  pure_result;
			std::string	  result;


			const wchar_t * subkey_pid  = (L"Software\\Microsoft\\Windows NT\\CurrentVersion");
			const wchar_t * subkey_guid = (L"Software\\Microsoft\\Cryptography");
			const char	  hex_chars[17] = "0123456789ABCDEF";
 
			dwBufSize = sizeof(buf);
			if( RegOpenKeyW(HKEY_LOCAL_MACHINE,subkey_pid,&hKey) == ERROR_SUCCESS)
			{
				dwType = REG_BINARY;
				if( RegQueryValueExW(hKey,(L"ProductId"),0, &dwType, (BYTE*)buf, &dwBufSize) == ERROR_SUCCESS)
				{
					pure_result += wchar2s(buf,dwBufSize);
				}
				RegCloseKey(hKey);
			}

			dwBufSize = sizeof(buf);
			if( RegOpenKeyW(HKEY_LOCAL_MACHINE,subkey_guid,&hKey) == ERROR_SUCCESS)
			{
				dwType = REG_BINARY;
				if( RegQueryValueExW(hKey,(L"MachineGuid"),0, &dwType, (BYTE*)buf, &dwBufSize) == ERROR_SUCCESS)
				{
					pure_result += wchar2s(buf,dwBufSize);
				}
				RegCloseKey(hKey);
			}

			for(ii = 0; ii < (int)pure_result.size();ii++)
			{
				result.push_back( hex_chars[((pure_result[ii]) & 0xF0)>>4] );
				result.push_back( hex_chars[(pure_result[ii]) & 0x0F] );
			}

			return result;

		};

	};
};
	


#endif